package core

import (
	"math"

	"git.akyoto.dev/cli/q/src/asm"
	"git.akyoto.dev/cli/q/src/expression"
)

// CompileLen returns the length of a slice.
func (f *Function) CompileLen(root *expression.Expression) error {
	_, register, isTemporary, err := f.Evaluate(root.Children[1])

	if err != nil {
		return err
	}

	f.SaveRegister(f.CPU.Output[0])
	f.MemoryRegister(asm.LOAD, asm.Memory{Base: register, Offset: -8, OffsetRegister: math.MaxUint8, Length: 8}, f.CPU.Output[0])

	if isTemporary {
		f.FreeRegister(register)
	}

	return nil
}
