package core

import (
	"git.akyoto.dev/cli/q/src/dll"
	"git.akyoto.dev/cli/q/src/fs"
	"git.akyoto.dev/cli/q/src/register"
	"git.akyoto.dev/cli/q/src/token"
	"git.akyoto.dev/cli/q/src/types"
)

// Function represents the smallest unit of code.
type Function struct {
	register.Machine
	Package    string
	Name       string
	UniqueName string
	File       *fs.File
	Body       token.List
	Input      []*Input
	Output     []*Output
	Functions  map[string]*Function
	Structs    map[string]*types.Struct
	DLLs       dll.List
	Err        error
	deferred   []func()
	count      counter
}

// counter stores how often a certain statement appeared so we can generate a unique label from it.
type counter struct {
	assert      int
	branch      int
	multiBranch int
	data        int
	loop        int
	subBranch   int
}
